#include	<pic18.h>
#include	"lcd.h"
#include	"delay.h"

#define	LCD_RS RC4
#define LCD_EN RC5

#define LCD_DATA	PORTB

static const char cyr[67]=
{
'A',	// 
160,	// 
'B',	// 
161,	// 
224,	// 
'E',	// 
//	162,	// 
163,	// 
164,	// 
165,	// 
166,	// 
'K',	// K
167,	// 
'M',	// M
'H',	// H
'O',	// O
168,	// 
'P',	// P
'C',	// C
'T',	// T
169,	// 
170,	// 
'X',	// X
225,	// 
171,	// 
172,	// 
226,	// 
173,	// 
174,	// 
'b',	// 
175,	// 
176,	// 
177,	// 
'a',	// 
178,	// 
179,	// 
180,	// 
227,	// 
'e',	// e
//	181,	// 
182,	// 
183,	// 
184,	// 
185,	// 
186,	// 
187,	// 
188,	// 
189,	// 
'o',	// o
190,	// 
'p',	// 
'c',	// 
191,	// 
'y',	// y
228,	// 
'x',	// x
229,	// 
192,	// 
193,	// 
230,	// 
194,	// 
195,	// 
196,	// 
197,	// 
198,	// 
199,	// 
};

char chr_to_cyr (char ch)
{
if		(ch==168)	ch = 162;
else if	(ch==184)	ch = 181;
else if	(ch>=192) 	ch = cyr[ch-192];
return ch;
}

void LCD_STROBE()	{LCD_EN = 1;DelayUs(1);LCD_EN=0;}

void lcd_write(unsigned char c)
{
char tmp ;
	DelayUs(50);

LCD_DATA = (c & 0xF0);

DelayUs(5);
DelayUs(2);	LCD_STROBE();

DelayUs(10);

LCD_DATA = ((c<<4) & 0xF0);


DelayUs(5);
DelayUs(2);	LCD_STROBE();

}

void lcd_clear(void)
{
	LCD_RS = 0;
	lcd_write(0x1);
	DelayMs(2);
}

void lcd_puts(const char * s)
{
	LCD_RS = 1;	// write characters
	while(*s)
		lcd_write(chr_to_cyr (*s++));
}

void lcd_putch(char c)
{
	LCD_RS = 1;	// write characters
	lcd_write( chr_to_cyr (c) );
}

void lcd_init()
{
char init_value;

ADCON1 = 7;	//PORTA -  ( .  )

	init_value = 0x30;
	TRISC4=0;
	TRISC5=0;
	RC4=0;
	RC5=0;

	TRISB=0b00001111;

	LCD_RS = 0;
	LCD_EN = 0;
	
	DelayMs(15);	// wait 15mSec after power applied,
	LCD_DATA	 = init_value;
	LCD_STROBE();
	DelayMs(10);
	LCD_STROBE();
	DelayUs(200);
	LCD_STROBE();
	DelayUs(200);
	LCD_DATA = 0x20;	// Four bit mode
	LCD_STROBE();
	DelayUs(200);
	lcd_write(0x28); // Set interface length
	lcd_write(0b1100); // Display On, Cursor off, Cursor Blink off
	lcd_clear();	// Clear screen
	lcd_write(0x60); // Set entry Mode
}

//********************************************//
void putch(unsigned char byte) 
{
lcd_putch(byte);
}
//********************************************//
//********************************************//
const char const LCD_ROW_ADDRESS[] =					
	{
	0x00,
	0x40
	};
//********************************************//
//********************************************//
void lcd_gotoxy (char row, char col)					// Position cursor
	{

	row = LCD_ROW_ADDRESS[row];					// Get address of first byte on desired row
	row += col ;
	LCD_RS = 0;
	lcd_write(0x80 | row);					// Write new cursor address
	}
